Index: program/steps/addressbook/list.inc
===================================================================
--- program/steps/addressbook/list.inc	(revision 360)
+++ program/steps/addressbook/list.inc	(working copy)
@@ -16,41 +16,77 @@
  +-----------------------------------------------------------------------+
 
  $Id$
-
 */
 
 $REMOTE_REQUEST = TRUE;
+$OUTPUT_TYPE = 'js';
 
-// count contacts for this user
-$sql_result = $DB->query("SELECT COUNT(contact_id) AS rows
-                          FROM ".get_table_name('contacts')."
-                          WHERE  del<>1
-                          AND    user_id=?",
-                          $_SESSION['user_id']);
-                                   
-$sql_arr = $DB->fetch_assoc($sql_result);
-$rowcount = $sql_arr['rows'];    
+    $commands = '';
+    
+    $sort = $_GET['_mbox'];
 
-// update message count display
-$pages = ceil($rowcount/$CONFIG['pagesize']);
-$commands = sprintf("this.set_rowcount('%s');\n", rcmail_get_rowcount_text($rowcount));
-$commands .= sprintf("this.set_env('pagecount', %d);\n", $pages);
+    if($sort == 'last_imported')
+      $sel = "import = 1 AND del<>1";
+    else if($sort == 'all')
+      $sel = "del<>1";
+    else
+     {
+      $sql_result = $DB->query("SELECT contact_ids FROM ".get_table_name('contactgroups')."
+                                  WHERE  user_id=?
+                                  AND user_groups=?",
+                                  $_SESSION['user_id'],
+                                  $sort);
+                               
+      $sql_arr = $DB->fetch_assoc($sql_result);
+      $contact_arr = unserialize($sql_arr['contact_ids']);
+      
+      // set our search vaules for the DB
+      $sel = "( ";
+      for($i=0; $i<count($contact_arr); $i++){
+        if($contact_arr[$i])
+        $sel .= " contact_id = $contact_arr[$i]";
+        
+        if($contact_arr[$i] && $i != (count($contact_arr)-1))
+          $sel .= " OR";
+      }
+      $sel .= ") AND del<>1";
+      
+    }
 
-$start_row = ($CONTACTS_LIST['page']-1) * $CONFIG['pagesize'];
+  // count contacts for this user
+  $sql_result = $DB->query("SELECT COUNT(contact_id) AS rows
+                            FROM ".get_table_name('contacts')."
+                            WHERE  ".$sel."
+                            AND    user_id=?",
+                            $_SESSION['user_id']);
+                                     
+  $sql_arr = $DB->fetch_assoc($sql_result);
+  $rowcount = $sql_arr['rows'];    
 
-// get contacts from DB
-$sql_result = $DB->limitquery("SELECT * FROM ".get_table_name('contacts')."
-                               WHERE  del<>1
-                               AND    user_id=?
-                               ORDER BY name",
-                               $start_row,
-                               $CONFIG['pagesize'],
-                               $_SESSION['user_id']);
-                                 
-$commands .= rcmail_js_contacts_list($sql_result);
+
+
+  // update contact count display
+  $pages = ceil($rowcount/$CONFIG['pagesize']);
+  $commands .= sprintf("this.set_rowcount('%s');\n", rcmail_get_rowcount_text($rowcount));
+  $commands .= sprintf("this.set_env('pagecount', %d);\n", $pages);
   
+  $start_row = ($CONTACTS_LIST['page']-1) * $CONFIG['pagesize'];
+  
+  
+  
+  // get contacts from DB
+  $sql_result = $DB->query("SELECT * FROM ".get_table_name('contacts')."
+                                 WHERE  ".$sel."
+                                 AND user_id=?
+                                 ORDER BY name",
+                                 $_SESSION['user_id']);
+                                                
+  $commands .= rcmail_js_contacts_list($sql_result);
+
+
+
 // send response
 rcube_remote_response($commands);
 
 exit;
-?>
\ No newline at end of file
+?>
Index: program/steps/addressbook/move.inc
===================================================================
--- program/steps/addressbook/move.inc	(revision 0)
+++ program/steps/addressbook/move.inc	(revision 0)
@@ -0,0 +1,66 @@
+<?php
+
+/*
+ +-----------------------------------------------------------------------+
+ | program/steps/mail/move_del.inc                                       |
+ |                                                                       |
+ | This file is part of the RoundCube Webmail client                     |
+ | Copyright (C) 2005, RoundCube Dev. - Switzerland                      |
+ | Licensed under the GNU GPL                                            |
+ |                                                                       |
+ | PURPOSE:                                                              |
+ |   Move the submitted messages to a specific mailbox or delete them    |
+ |                                                                       |
+ +-----------------------------------------------------------------------+
+ | Author: Thomas Bruederli <roundcube@gmail.com>                        |
+ +-----------------------------------------------------------------------+
+
+ $Id: move_del.inc 269 2006-06-29 23:41:40Z richs $
+
+*/
+
+$REMOTE_REQUEST = TRUE;
+
+// move messages
+if ($_action=='moveto' && $_GET['_cid'] && $_GET['_target_mbox'])
+  { 
+        $mbox = $_GET['_target_mbox'];
+        
+        // get grouping array as it stands
+        $sql_result = $DB->query("SELECT contact_ids FROM ".get_table_name('contactgroups')."
+                                  WHERE  user_id=?
+                                  AND user_groups=?",
+                                  $_SESSION['user_id'],
+                                  $mbox);
+                               
+        $sql_arr = $DB->fetch_assoc($sql_result);
+        
+        $group_arr = unserialize($sql_arr['contact_ids']);
+        $current_arr = explode(',',$_GET['_cid']);
+        $result = array_merge($group_arr, $current_arr);
+        $result = serialize (array_unique($result));
+          
+        $DB->query("UPDATE ".get_table_name('contactgroups')."
+                    SET   contact_ids =?
+                    WHERE  user_groups=?
+                    AND user_id=?",
+                    $result,
+                    $mbox,
+                    $_SESSION['user_id']);
+                           
+         //$count = $DB->affected_rows();
+        
+  }
+  else
+  {
+    // something weird going on as we should only have those variables
+   exit;
+  }
+ 
+  //$commands = sprintf("alert('%s');\n", "remote reply : $result"); 
+  
+// send response
+rcube_remote_response($commands);
+
+exit;
+?>
Index: program/steps/addressbook/save.inc
===================================================================
--- program/steps/addressbook/save.inc	(revision 360)
+++ program/steps/addressbook/save.inc	(working copy)
@@ -28,7 +28,44 @@
   }
 
 // setup some vars we need
-$a_save_cols = array('name', 'firstname', 'surname', 'email');
+$a_save_cols = array(
+    'name',
+    'email',
+    'firstname',
+    'middlename',
+    'lastname',
+    'maidenname',
+    'prefix',
+    'suffix',
+    'gender',
+    'email1',
+    'email2',
+    'phone_home',
+    'phone_pager',
+    'phone_mobile',
+    'phone_work',
+    'phone_fax',
+    'phone_other',
+    'company_name',
+    'company_title',
+    'company_street',
+    'company_city',
+    'company_state',
+    'company_zip',
+    'company_country',
+    'company_website',
+    'personal_street',
+    'personal_city',
+    'personal_state',
+    'personal_zip',
+    'personal_country',
+    'personal_website',
+    'str_birthday',
+    'str_deathday',
+    'str_anniversary',
+    'comments',
+    'image'
+  );
 $contacts_table = get_table_name('contacts');
 
 // update an existing contact
@@ -126,8 +163,8 @@
     $sql .= ")";
     $ldap_form = true; 
     }
-  else if (isset($_POST['_email'])) 
-    $sql  .= "AND email = " . $DB->quote(get_input_value('_email', RCUBE_INPUT_POST));
+  else if (isset($_POST['_name'])) 
+    $sql  .= "AND name = " . $DB->quote(get_input_value('_name', RCUBE_INPUT_POST));
 
   $sql_result = $DB->query($sql);
 
@@ -171,8 +208,8 @@
     if (sizeof($a_insert_cols))
       {
       $DB->query("INSERT INTO $contacts_table
-                  (user_id, changed, del, ".join(', ', $a_insert_cols).")
-                  VALUES (?, ".$DB->now().", 0, ".join(', ', $a_insert_values).")",
+                  (user_id, changed, del, import, ".join(', ', $a_insert_cols).")
+                  VALUES (?, ".$DB->now().", 0, 0, ".join(', ', $a_insert_values).")",
                 $_SESSION['user_id']);
                        
       $insert_id = $DB->insert_id(get_sequence_name('contacts'));
Index: program/steps/addressbook/search.inc
===================================================================
--- program/steps/addressbook/search.inc	(revision 0)
+++ program/steps/addressbook/search.inc	(revision 0)
@@ -0,0 +1,114 @@
+<?php
+/*
+ +-----------------------------------------------------------------------+
+ | steps/addressbook/search.inc                                          |
+ |                                                                       |
+ | Search functions for rc contacts                                      |
+ | Licensed under the GNU GPL                                            |
+ |                                                                       |
+ +-----------------------------------------------------------------------+
+ | Author: Shane Saunders <shane@gnative.com>                            |
+ +-----------------------------------------------------------------------+
+
+*/
+
+$REMOTE_REQUEST = TRUE;
+
+// get search string
+$search_str = get_input_value('_search', RCUBE_INPUT_GET);
+$mbox = get_input_value('_mbox', RCUBE_INPUT_GET);
+//$search_request = md5($str);
+
+$commands = '';
+$count = 0;
+  
+// Make sure our $search is legit..
+if ($search_str != '')
+{  
+          // setup some vars we need
+      $a_cols = array(
+        'name',
+        'email',
+        'firstname',
+        'middlename',
+        'lastname',
+        'maidenname',
+        'prefix',
+        'suffix',
+        'gender',
+        'email1',
+        'email2',
+        'phone_home',
+        'phone_pager',
+        'phone_mobile',
+        'phone_work',
+        'phone_fax',
+        'phone_other',
+        'company_name',
+        'company_title',
+        'company_street',
+        'company_city',
+        'company_state',
+        'company_zip',
+        'company_country',
+        'company_website',
+        'personal_street',
+        'personal_city',
+        'personal_state',
+        'personal_zip',
+        'personal_country',
+        'personal_website',
+        'str_birthday',
+        'str_deathday',
+        'str_anniversary',
+        'comments'
+        );
+      
+      // create out string search for DB
+      $sStr = '';
+      for($i=0; $i<count($a_cols); $i++)
+      {
+          if($i == 0)
+            $sStr .= "(".$a_cols[$i]." LIKE '%$search_str%' )";
+          else
+            $sStr .= "OR (".$a_cols[$i]." LIKE '%$search_str%'  )";
+      }
+
+
+    // get contacts from DB
+    $sql_result = $DB->query("SELECT * FROM ".get_table_name('contacts')."
+                              WHERE  user_id=".$_SESSION['user_id']."
+                              AND (".$sStr.")
+                              AND del<>1
+                              ORDER BY name");
+    
+    // count contacts for this user
+    $sql_row_result = $DB->query("SELECT COUNT(contact_id) AS rows
+                                FROM ".get_table_name('contacts')."
+                                WHERE  user_id=".$_SESSION['user_id']."
+                                AND (".$sStr.")
+                                AND del<>1");
+                                     
+    $sql_arr = $DB->fetch_assoc($sql_row_result);
+    $rowcount = $sql_arr['rows'];  
+                         
+    // Make sure we got the headers
+  if ($rowcount>0)
+  {
+    $commands .= show_message('contactsearchsuccessful', 'confirmation', array('nr' => $rowcount));
+    $commands .= rcmail_js_contacts_list($sql_result);
+  }    
+  else
+  {
+    $commands .= show_message('searchnomatch', 'warning');
+  }
+  
+    //update contact count display
+    $commands .= sprintf("\nthis.set_env('search_request', '%s')\n", $search_request);
+    $commands .= sprintf("this.set_rowcount('%s');\n", rcmail_get_rowcount_text($rowcount));
+    $commands .= sprintf("this.set_env('pagecount', %d);\n", $pages);
+    $commands .= sprintf("this.select_groupbox('%s');\n", "null");
+}
+
+  rcube_remote_response($commands);
+?>
Index: program/steps/addressbook/show.inc
===================================================================
--- program/steps/addressbook/show.inc	(revision 360)
+++ program/steps/addressbook/show.inc	(working copy)
@@ -19,7 +19,6 @@
 
 */
 
-
 if ($_GET['_cid'] || $_POST['_cid'])
   {
   $cid = $_POST['_cid'] ? $_POST['_cid'] : $_GET['_cid'];
@@ -52,24 +51,64 @@
 
   // return the complete address record as table
   $out = "<table>\n\n";
-
-  $a_show_cols = array('name', 'firstname', 'surname', 'email');
+  
+  $a_show_cols = array(
+    'name',
+    'email',
+    'firstname',
+    'middlename',
+    'lastname',
+    'maidenname',
+    'prefix',
+    'suffix',
+    'gender',
+    'email1',
+    'email2',
+    'phone_home',
+    'phone_pager',
+    'phone_mobile',
+    'phone_work',
+    'phone_fax',
+    'phone_other',
+    'company_name',
+    'company_title',
+    'company_street',
+    'company_city',
+    'company_state',
+    'company_zip',
+    'company_country',
+    'company_website',
+    'personal_street',
+    'personal_city',
+    'personal_state',
+    'personal_zip',
+    'personal_country',
+    'personal_website',
+    'str_birthday',
+    'str_deathday',
+    'str_anniversary',
+    'comments',
+    'image'
+  );
+  
   foreach ($a_show_cols as $col)
     {
-    if ($col=='email' && $CONTACT_RECORD[$col])
-      $value = sprintf('<a href="#compose" onclick="%s.command(\'compose\', %d)" title="%s">%s</a>',
-                       $JS_OBJECT_NAME,
-                       $CONTACT_RECORD['contact_id'],
-                       rcube_label('composeto'),
-                       $CONTACT_RECORD[$col]);
-    else
-      $value = rep_specialchars_output($CONTACT_RECORD[$col]);
-    
-    $title = rcube_label($col);
-    $out .= sprintf("<tr><td class=\"title\">%s</td><td>%s</td></tr>\n", $title, $value);
+      if($CONTACT_RECORD[$col])
+      {
+          if (substr($col,0,5)=='email' && $CONTACT_RECORD[$col])
+          $value = sprintf('<a href="#compose" onclick="%s.command(\'compose\', \'%d_%s\')" title="%s">%s</a>',
+                             $JS_OBJECT_NAME,
+                             $CONTACT_RECORD['contact_id'],
+                             $col,
+                             rcube_label('composeto'),
+                             $CONTACT_RECORD[$col]); 
+          else
+            $value = rep_specialchars_output($CONTACT_RECORD[$col]);
+          
+          $title = rcube_label($col);
+          $out .= sprintf("<tr><td class=\"title\">%s</td><td>%s</td></tr>\n", $title, $value);
+       }
     }
-
-
   $out .= "\n</table>";
   
   return $out;  
@@ -77,4 +116,4 @@
 
 
 parse_template('showcontact');
-?>
\ No newline at end of file
+?>
